SystemOrganization addCategory: #TPTodo!
SystemOrganization addCategory: #'TPTodo-Tests'!

TestCase subclass: #TPWorkItemListTest
	instanceVariableNames: 'subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPTodo-Tests'!

!TPWorkItemListTest methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 18:19:35.914'!
addFinishedItem 

	subject add: TPWorkItem new finish.! !

!TPWorkItemListTest methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 18:18:35.812'!
addFinishedItems: aNumber

	aNumber timesRepeat: [self addFinishedItem] ! !

!TPWorkItemListTest methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 18:18:07.026'!
addUnfinishedItem 

	subject add: TPWorkItem new.! !

!TPWorkItemListTest methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 18:17:14.922'!
addUnfinishedItems: aNumber

	aNumber timesRepeat: [self addUnfinishedItem]  ! !

!TPWorkItemListTest methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 18:06:42.114'!
setUp
	
	subject := TPWorkItemList new.! !

!TPWorkItemListTest methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 19:43:23.62'!
testAddingAnItem

	|item|
	item := TPWorkItem new description: 'abc'.
	subject add: item.
	self assert: (subject at: 1) description equals: item description ! !

!TPWorkItemListTest methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 19:42:46.97'!
testDoRunsThrough

	|counter|
	subject 
		add: TPWorkItem new;
		add: TPWorkItem new.
	counter := 0.
	subject do: [:e | counter := counter + 1].
	self assert: 2 equals: counter.  ! !

!TPWorkItemListTest methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 19:26:38.428'!
testFinishedItems

	self addUnfinishedItems: 4.
	self addFinishedItems: 3.
	self assert: subject finishedItems size equals: 3     ! !

!TPWorkItemListTest methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 18:07:52.616'!
testIsEmptyWhenInitialized

	self assert: subject isEmpty! !

!TPWorkItemListTest methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 18:11:47.288'!
testNotEmptyAfterAdding

	subject add: TPWorkItem new.
	self deny: subject isEmpty. ! !

!TPWorkItemListTest methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 19:27:08.31'!
testUnfinishedItems

	self addUnfinishedItems: 4.
	self addFinishedItems: 3.
	self assert: subject unfinishedItems size equals: 4! !

TestCase subclass: #TPWorkItemTest
	instanceVariableNames: 'subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPTodo-Tests'!

!TPWorkItemTest methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 16:25:20.63'!
setUp

	subject := TPWorkItem new.
	super! !

!TPWorkItemTest methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 16:12:11.58'!
testDescription

	subject description: 'Blablabla'.
	self assert: subject description equals: 'Blablabla'   ! !

!TPWorkItemTest methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 16:22:06.048'!
testFinish

	subject finish.
	self assert: subject isFinished   ! !

!TPWorkItemTest methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 16:21:37.884'!
testNewItemUnfinished

	self deny: subject isFinished   ! !

!TPWorkItemTest methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 17:41:36.806'!
testShortDescription

	|description|
	description := ''.
	(1 to: 160) do: [:e | description := description , 'A'].
	subject description: description.
	self assert: TPWorkItem shortDescriptionSize equals: subject shortDescription size! !

!TPWorkItemTest methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 17:49:41.05'!
testShortDescriptionForAShortDescription

subject description: 'abc'.
self assert: 'abc' equals: subject shortDescription.   ! !

Object subclass: #TPTodoListGUI
	instanceVariableNames: 'gui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPTodo'!

!TPTodoListGUI class methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 21:00:16.496'!
initializeWith: aTPWorkItemList

	|thingy|
	thingy := self new.! !

!TPTodoListGUI class methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 21:01:20.816'!
openWith: aTPWorkItemList

	|thingy|
	thingy := self new.
	aTPWorkItemList do: [:item | thingy addItem: item].
	thingy openInWorld.! !

!TPTodoListGUI methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 21:08:23.168'!
addItem: item

	gui addMorph: (TextMorph new contents: item description) .	! !

!TPTodoListGUI methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 21:10:19.558'!
initialize

	|m|
	super.
	m := RectangleMorph new.
	m layoutPolicy: TableLayout new.
	m listDirection: #topToBottom.
	m hResizing: #shrinkWrap; 	vResizing: #shrinkWrap.
	m layoutInset: 20; cellInset: 10.
	gui := m.
! !

!TPTodoListGUI methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 21:09:09.494'!
openInWorld 
	gui openInWorld.! !

Object subclass: #TPWorkItem
	instanceVariableNames: 'status description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPTodo'!

!TPWorkItem class methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 16:24:46.774'!
shortDescriptionSize 

	^ 40! !

!TPWorkItem methodsFor: 'accessing' stamp: 'TP 1/13/2013 16:24:02.248'!
description
	^ description! !

!TPWorkItem methodsFor: 'accessing' stamp: 'TP 1/13/2013 16:24:02.252'!
description: anObject
	description := anObject! !

!TPWorkItem methodsFor: 'accessing' stamp: 'TP 1/13/2013 16:27:28.9'!
finish
	
	status := #finished.! !

!TPWorkItem methodsFor: 'accessing' stamp: 'TP 1/13/2013 16:28:39.264'!
initialize
	
	super.
	status := #unfinished.! !

!TPWorkItem methodsFor: 'accessing' stamp: 'TP 1/13/2013 16:26:55.656'!
isFinished
	
	^ status = #finished! !

!TPWorkItem methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 17:51:39.714'!
shortDescription

	^ (self description size > self class shortDescriptionSize) ifTrue: [self description copyFrom: 1 to: self class shortDescriptionSize] ifFalse: [self description]  ! !

Object subclass: #TPWorkItemList
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPTodo'!

!TPWorkItemList methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 19:35:47.882'!
add: aWorkItem

	list add: aWorkItem.! !

!TPWorkItemList methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 19:36:08.728'!
at: index

	^ list at: index ! !

!TPWorkItemList methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 19:36:30.588'!
do: aBlock

	list do: aBlock ! !

!TPWorkItemList methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 19:37:13.394'!
finishedItems 

	^ list select: [:workItem | workItem isFinished]  ! !

!TPWorkItemList methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 19:41:57.606'!
initialize 
	super.
	list := OrderedCollection new.
	! !

!TPWorkItemList methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 19:43:54.626'!
isEmpty

	^ list isEmpty ! !

!TPWorkItemList methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 20:30:15.228'!
modelReset! !

!TPWorkItemList methodsFor: 'as yet unclassified' stamp: 'TP 1/13/2013 19:37:38.89'!
unfinishedItems 

	^ list reject: [:workItem | workItem isFinished]! !
